=== debian/changelog ===
chromono (1.1.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with GCC-15. (Closes: #1114081)
  * Switch from pkg-config to pkgconf.

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 14 Sep 2025 19:40:57 +0200

chromono (1.1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change rebuild to allow testing migration after NEW acceptance.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 06 Nov 2021 13:05:29 +0000

chromono (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #992342)

 -- Thomas Perl <m@thp.io>  Tue, 17 Aug 2021 16:31:03 +0200
