=== debian/control ===
Source: chromono
Section: games
Priority: optional
Maintainer: Thomas Perl <m@thp.io>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13), pkgconf,
 python3 (>= 3.3), libsdl2-dev, libgl-dev, zlib1g-dev, libvorbis-dev
Standards-Version: 4.5.1
Homepage: https://thp.io/2013/chromono/

Package: chromono
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Circular color puzzle game
 chro.mono is a puzzle game originally developed in 2013 for mobile devices.
 The goal of the game is to touch half-colored spheres with full-colored
 spheres in such a way that all spheres are filledwith a single color each.
 Later on in the game, additional limitations and variations on the game
 mechanics plus time limits keep the gameplay interesting.
