=== debian/changelog ===
chromono (1.1.3-1) unstable; urgency=medium

  * New upstream release, per info from Thomas.
    GCC-15 build fix is included in this release.
  * Add myself to Uploaders.
  * Remove version constraints satisfied since at least buster.
  * Add Build-Depends: libopengl-dev for cmake's OpenGL::OpenGL.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 03 Jan 2026 16:28:54 +0100
