=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: games
 Priority: optional
 Maintainer: Thomas Perl <m@thp.io>
-Build-Depends: debhelper-compat (= 13), cmake (>= 3.13), pkgconf,
- python3 (>= 3.3), libsdl2-dev, libgl-dev, zlib1g-dev, libvorbis-dev
+Uploaders: Chris Hofstaedtler <zeha@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, pkgconf,
+ python3, libsdl2-dev, libopengl-dev, libgl-dev, zlib1g-dev, libvorbis-dev
 Standards-Version: 4.5.1
 Homepage: https://thp.io/2013/chromono/
